%global commit e4292c8f1bd2580a44d3cbf3570a4505bd3a74b6

Summary:        GCJ-free toolkit for manipulating PDF documents
Name:           pdftk-java
Version:        3.3.3
Release:    1%{?dist}
License:        GPL-2.0-or-later AND LGPL-2.0-or-later AND APAFML AND Apache-2.0
URL:            https://gitlab.com/pdftk-java/pdftk
Source0:        https://gitlab.com/pdftk-java/pdftk/-/archive/v%{version}/pdftk-%{version}.tar.gz
Patch0:         pdftk-java-3.3.1-classpath.patch
BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch
BuildRequires:  ant
BuildRequires:  bouncycastle >= 1.63
BuildRequires:  apache-commons-lang3 >= 3.3
BuildRequires:  javapackages-local
Requires:       java-headless
Requires:       bouncycastle
Requires:       apache-commons-lang3
Requires:       javapackages-tools
Provides:       bundled(itext) = 2.1.7-4.2.0.modified_by_pdftk
Provides:       pdftk = %{version}-%{release}

%description
If PDF is electronic paper, then pdftk-java is an electronic staple-remover,
hole-punch, binder, secret-decoder-ring, and X-Ray-glasses. PDFtk is a simple
tool for doing everyday things with PDF documents: Merge PDF documents, split
PDF pages into a new document, decrypt input as necessary (password required),
encrypt output as desired, burst a PDF document into single pages, report on
PDF metrics, including metadata and bookmarks, uncompress and re-compress page
streams, and repair corrupted PDF (where possible).

Pdftk-java is a port of the original GCJ-based PDFtk to Java. The GNU Compiler
for Java (GCJ) is a portable, optimizing, ahead-of-time compiler for the Java
programming language, which had no new developments since 2009 and was finally
removed in 2016 from the GCC development tree before the release of GCC 7.

%prep
%setup -q -n pdftk-v%{version}-%{commit}
%patch0 -p1 -b .classpath

%build
ant -Dant.build.javac.target=1.8 -Dant.build.javac.source=1.8 jar

%install
install -D -p -m 0644 build/jar/pdftk.jar %{buildroot}%{_javadir}/pdftk.jar
install -D -p -m 0644 pdftk.1 %{buildroot}%{_mandir}/man1/pdftk.1

%jpackage_script com.gitlab.pdftk_java.pdftk "" "" bcprov:commons-lang3:pdftk pdftk true

%check
sed -e 's| pdftk"|"|' %{buildroot}%{_bindir}/pdftk > pdftk
chmod 755 pdftk
export CLASSPATH="%{buildroot}%{_javadir}/pdftk.jar"
set -euo pipefail

./pdftk test/files/duck.pdf test/files/duck.pdf output two-ducks.pdf
./pdftk two-ducks.pdf dump_data | grep -q "NumberOfPages: 2"

./pdftk test/files/duck.pdf rotate 1east output rotated-duck.pdf
./pdftk rotated-duck.pdf dump_data | grep -q "PageMediaRotation: 90"

%files
%license LICENSE license_gpl_pdftk/reference/{apache,gnu_lgpl}_license_2.txt
%license java/com/gitlab/pdftk_java/com/lowagie/text/pdf/fonts/License-Adobe.txt
%doc CHANGELOG.md README.md
%{_bindir}/pdftk
%{_javadir}/pdftk.jar
%{_mandir}/man1/pdftk.1*

%changelog
* Tue Aug 27 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.3-1
- initial build
